
public class Borrower
{
   private int id;
   private String name;
   private Book borrowed[];
   private int numBorrowed;

   public Borrower( int id, String name )
   {
      this.id = id;
      this.name = name;
      this.borrowed = new Book[5];
      this.numBorrowed = 0;
   }

   public void borrowBook( Book bk )
   {
      this.borrowed[ numBorrowed ] = bk;
      numBorrowed = numBorrowed + 1;
	  bk.setBorrower( this );
   }

   public void returnAllBooks()
   {
      for( int i = 0; i < numBorrowed; i++ )
      {
         borrowed[i].setBorrower( null );
         borrowed[i] = null;
      }
      numBorrowed = 0;
   }

   public void removeBook( Book bk )
   {
      int location = 0;
      while ( location < numBorrowed &&
              borrowed[location] != bk )
      {
         location++;
      }
      if ( location == numBorrowed - 1 )
         borrowed[location] = null;
      else
      {
         borrowed[location] = borrowed[numBorrowed - 1];
         borrowed[numBorrowed - 1] = null;
      }
      numBorrowed = numBorrowed - 1;
   }

   public boolean borrowAllowed()
   {
      return ( numBorrowed < 5 );
   }

   public void listBorrowedBooks()
   {
      for( int i = 0; i < numBorrowed; i++ )
      {
         // print Book info
         this.borrowed[i].printBook();
      }
   }
}
